diff -r -uw -N irrlicht/source/Irrlicht/CD3D9Driver.cpp irrlicht_multipatch/source/Irrlicht/CD3D9Driver.cpp
--- irrlicht/source/Irrlicht/CD3D9Driver.cpp	2006-10-15 08:48:50.000000000 +0200
+++ irrlicht_multipatch/source/Irrlicht/CD3D9Driver.cpp	2006-12-05 11:50:24.000000000 +0100
@@ -48,19 +48,6 @@
 		LastTextureMipMapsAvailable[i] = false;
 	}
 
-	// create sphere map matrix
-
-	SphereMapMatrixD3D9._11 = 0.5f; SphereMapMatrixD3D9._12 = 0.0f;
-	SphereMapMatrixD3D9._13 = 0.0f; SphereMapMatrixD3D9._14 = 0.0f;
-	SphereMapMatrixD3D9._21 = 0.0f; SphereMapMatrixD3D9._22 =-0.5f;
-	SphereMapMatrixD3D9._23 = 0.0f; SphereMapMatrixD3D9._24 = 0.0f;
-	SphereMapMatrixD3D9._31 = 0.0f; SphereMapMatrixD3D9._32 = 0.0f;
-	SphereMapMatrixD3D9._33 = 1.0f; SphereMapMatrixD3D9._34 = 0.0f;
-	SphereMapMatrixD3D9._41 = 0.5f; SphereMapMatrixD3D9._42 = 0.5f;
-	SphereMapMatrixD3D9._43 = 0.0f; SphereMapMatrixD3D9._44 = 1.0f;
-
-	core::matrix4 mat;
-	UnitMatrixD3D9 = *(D3DMATRIX*)((void*)&mat);
 
 	// init direct 3d is done in the factory function
 
@@ -93,12 +80,15 @@
 {
 	// create D3D9 material renderers
 
-	addAndDropMaterialRenderer(new CD3D9MaterialRenderer_SOLID(pID3DDevice, this));
-	addAndDropMaterialRenderer(new CD3D9MaterialRenderer_SOLID_2_LAYER(pID3DDevice, this));
+	core::array<IDirect3DDevice9*> devices;
+	devices.push_back(pID3DDevice);
+
+	addAndDropMaterialRenderer(new CD3D9MaterialRenderer_SOLID(devices, this));
+	addAndDropMaterialRenderer(new CD3D9MaterialRenderer_SOLID_2_LAYER(devices, this));
 
 	// add the same renderer for all lightmap types
 
-	CD3D9MaterialRenderer_LIGHTMAP* lmr = new CD3D9MaterialRenderer_LIGHTMAP(pID3DDevice, this);
+	CD3D9MaterialRenderer_LIGHTMAP* lmr = new CD3D9MaterialRenderer_LIGHTMAP(devices, this);
 	addMaterialRenderer(lmr); // for EMT_LIGHTMAP:
 	addMaterialRenderer(lmr); // for EMT_LIGHTMAP_ADD:
 	addMaterialRenderer(lmr); // for EMT_LIGHTMAP_M2:
@@ -110,45 +100,47 @@
 
 	// add remaining fixed function pipeline material renderers
 
-	addAndDropMaterialRenderer(new CD3D9MaterialRenderer_DETAIL_MAP(pID3DDevice, this));
-	addAndDropMaterialRenderer(new CD3D9MaterialRenderer_SPHERE_MAP(pID3DDevice, this));
-	addAndDropMaterialRenderer(new CD3D9MaterialRenderer_REFLECTION_2_LAYER(pID3DDevice, this));
-	addAndDropMaterialRenderer(new CD3D9MaterialRenderer_TRANSPARENT_ADD_COLOR(pID3DDevice, this));
-	addAndDropMaterialRenderer(new CD3D9MaterialRenderer_TRANSPARENT_ALPHA_CHANNEL(pID3DDevice, this));
-	addAndDropMaterialRenderer(new CD3D9MaterialRenderer_TRANSPARENT_ALPHA_CHANNEL_REF(pID3DDevice, this));
-	addAndDropMaterialRenderer(new CD3D9MaterialRenderer_TRANSPARENT_VERTEX_ALPHA(pID3DDevice, this));
-	addAndDropMaterialRenderer(new CD3D9MaterialRenderer_TRANSPARENT_REFLECTION_2_LAYER(pID3DDevice, this));
+	addAndDropMaterialRenderer(new CD3D9MaterialRenderer_DETAIL_MAP(devices, this));
+	addAndDropMaterialRenderer(new CD3D9MaterialRenderer_SPHERE_MAP(devices, this));
+	addAndDropMaterialRenderer(new CD3D9MaterialRenderer_REFLECTION_2_LAYER(devices, this));
+	addAndDropMaterialRenderer(new CD3D9MaterialRenderer_TRANSPARENT_ADD_COLOR(devices, this));
+	addAndDropMaterialRenderer(new CD3D9MaterialRenderer_TRANSPARENT_ALPHA_CHANNEL(devices, this));
+	addAndDropMaterialRenderer(new CD3D9MaterialRenderer_TRANSPARENT_ALPHA_CHANNEL_REF(devices, this));
+	addAndDropMaterialRenderer(new CD3D9MaterialRenderer_TRANSPARENT_VERTEX_ALPHA(devices, this));
+	addAndDropMaterialRenderer(new CD3D9MaterialRenderer_TRANSPARENT_REFLECTION_2_LAYER(devices, this));
 
 	// add normal map renderers
 
 	s32 tmp = 0;
 	video::IMaterialRenderer* renderer = 0;
 
-	renderer = new CD3D9NormalMapRenderer(pID3DDevice, this, tmp,
+	renderer = new CD3D9NormalMapRenderer(devices, this, tmp,
 		MaterialRenderers[EMT_SOLID].Renderer);
 	renderer->drop();
 
-	renderer = new CD3D9NormalMapRenderer(pID3DDevice, this, tmp,
+	renderer = new CD3D9NormalMapRenderer(devices, this, tmp,
 		MaterialRenderers[EMT_TRANSPARENT_ADD_COLOR].Renderer);
 	renderer->drop();
 
-	renderer = new CD3D9NormalMapRenderer(pID3DDevice, this, tmp,
+	renderer = new CD3D9NormalMapRenderer(devices, this, tmp,
 		MaterialRenderers[EMT_TRANSPARENT_VERTEX_ALPHA].Renderer);
 	renderer->drop();
 
 	// add parallax map renderers
 
-	renderer = new CD3D9ParallaxMapRenderer(pID3DDevice, this, tmp,
+	renderer = new CD3D9ParallaxMapRenderer(devices, this, tmp,
 		MaterialRenderers[EMT_SOLID].Renderer);
 	renderer->drop();
 
-	renderer = new CD3D9ParallaxMapRenderer(pID3DDevice, this, tmp,
+	renderer = new CD3D9ParallaxMapRenderer(devices, this, tmp,
 		MaterialRenderers[EMT_TRANSPARENT_ADD_COLOR].Renderer);
 	renderer->drop();
 
-	renderer = new CD3D9ParallaxMapRenderer(pID3DDevice, this, tmp,
+	renderer = new CD3D9ParallaxMapRenderer(devices, this, tmp,
 		MaterialRenderers[EMT_TRANSPARENT_VERTEX_ALPHA].Renderer);
 	renderer->drop();
+
+	devices.clear();
 }
 
 
@@ -282,17 +274,17 @@
 	// check stencil buffer compatibility
 	if (StencilBuffer)
 	{
-		present.AutoDepthStencilFormat = D3DFMT_D24S8;
+		present.AutoDepthStencilFormat = D3DFMT_D16;
 		if(FAILED(pID3D->CheckDeviceFormat(D3DADAPTER_DEFAULT, devtype,
 			present.BackBufferFormat, D3DUSAGE_DEPTHSTENCIL,
-			D3DRTYPE_SURFACE, D3DFMT_D24S8)))
+			D3DRTYPE_SURFACE, D3DFMT_D16)))
 		{
 			os::Printer::log("Device does not support stencilbuffer, disabling stencil buffer.", ELL_WARNING);
 			StencilBuffer = false;
 		}
 		else
 		if(FAILED(pID3D->CheckDepthStencilMatch(D3DADAPTER_DEFAULT, devtype,
-			present.BackBufferFormat, present.BackBufferFormat, D3DFMT_D24S8)))
+			present.BackBufferFormat, present.BackBufferFormat, D3DFMT_D16)))
 		{
 			os::Printer::log("Depth-stencil format is not compatible with display format, disabling stencil buffer.", ELL_WARNING);
 			StencilBuffer = false;
@@ -300,7 +292,7 @@
 	}
 
 	if (!StencilBuffer)
-		present.AutoDepthStencilFormat = D3DFMT_D24X8;
+		present.AutoDepthStencilFormat = D3DFMT_D16;
 
 	// create device
 
@@ -481,7 +473,7 @@
 
 
 //! queries the features of the driver, returns true if feature is available
-bool CD3D9Driver::queryFeature(E_VIDEO_DRIVER_FEATURE feature)
+bool CD3D9Driver::queryFeature(E_VIDEO_DRIVER_FEATURE feature, s32 renderDevice)
 {
 	switch (feature)
 	{
@@ -736,7 +728,7 @@
 
 
 //! draws a vertex primitive list
-void CD3D9Driver::drawVertexPrimitiveList(const void* vertices, s32 vertexCount, const u16* indexList, s32 primitiveCount, E_VERTEX_TYPE vType, scene::E_PRIMITIVE_TYPE pType)
+void CD3D9Driver::drawVertexPrimitiveList(const void* vertices, s32 vertexCount, const u32* indexList, s32 primitiveCount, E_VERTEX_TYPE vType, scene::E_PRIMITIVE_TYPE pType)
 {
 	if (!checkPrimitiveCount(primitiveCount))
 		return;
@@ -767,16 +759,16 @@
 		{
 			case scene::EPT_POINTS:
 				pID3DDevice->DrawIndexedPrimitiveUP(D3DPT_POINTLIST, 0, vertexCount,
-					primitiveCount, indexList, D3DFMT_INDEX16, vertices, stride);
+					primitiveCount, indexList, D3DFMT_INDEX32, vertices, stride);
 				break;
 			case scene::EPT_LINE_STRIP:
 				pID3DDevice->DrawIndexedPrimitiveUP(D3DPT_LINESTRIP, 0, vertexCount,
-					primitiveCount, indexList, D3DFMT_INDEX16, vertices, stride);
+					primitiveCount, indexList, D3DFMT_INDEX32, vertices, stride);
 				break;
 			case scene::EPT_LINE_LOOP:
 			{
 				pID3DDevice->DrawIndexedPrimitiveUP(D3DPT_LINESTRIP, 0, vertexCount,
-					primitiveCount, indexList, D3DFMT_INDEX16, vertices, stride);
+					primitiveCount, indexList, D3DFMT_INDEX32, vertices, stride);
 				u16 tmpIndices[] = {0, primitiveCount};
 				pID3DDevice->DrawIndexedPrimitiveUP(D3DPT_LINELIST, 0, vertexCount,
 					1, tmpIndices, D3DFMT_INDEX16, vertices, stride);
@@ -784,19 +776,19 @@
 				break;
 			case scene::EPT_LINES:
 				pID3DDevice->DrawIndexedPrimitiveUP(D3DPT_LINELIST, 0, vertexCount,
-					primitiveCount, indexList, D3DFMT_INDEX16, vertices, stride);
+					primitiveCount, indexList, D3DFMT_INDEX32, vertices, stride);
 				break;
 			case scene::EPT_TRIANGLE_STRIP:
 				pID3DDevice->DrawIndexedPrimitiveUP(D3DPT_TRIANGLESTRIP, 0, vertexCount,
-					primitiveCount, indexList, D3DFMT_INDEX16, vertices, stride);
+					primitiveCount, indexList, D3DFMT_INDEX32, vertices, stride);
 				break;
 			case scene::EPT_TRIANGLE_FAN:
 				pID3DDevice->DrawIndexedPrimitiveUP(D3DPT_TRIANGLEFAN, 0, vertexCount,
-					primitiveCount, indexList, D3DFMT_INDEX16, vertices, stride);
+					primitiveCount, indexList, D3DFMT_INDEX32, vertices, stride);
 				break;
 			case scene::EPT_TRIANGLES:
 				pID3DDevice->DrawIndexedPrimitiveUP(D3DPT_TRIANGLELIST, 0, vertexCount,
-					primitiveCount, indexList, D3DFMT_INDEX16, vertices, stride);
+					primitiveCount, indexList, D3DFMT_INDEX32, vertices, stride);
 				break;
 		}
 	}
@@ -1450,6 +1442,7 @@
 	if (CurrentRenderMode != ERM_2D || Transformation3DChanged)
 	{
 		core::matrix4 mat;
+		core::matrix4 mat1;
 		pID3DDevice->SetTransform(D3DTS_VIEW, (D3DMATRIX*)((void*)&mat));
 		pID3DDevice->SetTransform(D3DTS_WORLD, (D3DMATRIX*)((void*)&mat));
 		pID3DDevice->SetTransform(D3DTS_PROJECTION, (D3DMATRIX*)((void*)&mat));
@@ -1470,7 +1463,7 @@
 
 		pID3DDevice->SetTextureStageState( 0, D3DTSS_TEXTURETRANSFORMFLAGS, D3DTTFF_DISABLE );
 		pID3DDevice->SetTextureStageState( 0, D3DTSS_TEXCOORDINDEX, 0);
-		pID3DDevice->SetTransform( D3DTS_TEXTURE0, &UnitMatrixD3D9 );
+		pID3DDevice->SetTransform( D3DTS_TEXTURE0, (D3DMATRIX*)((void*)&mat1) );
 
 		Transformation3DChanged = false;
 
@@ -1895,11 +1888,15 @@
 	E_MATERIAL_TYPE baseMaterial, s32 userData)
 {
 	s32 nr = -1;
+	core::array<IDirect3DDevice9*> dev;
+	dev.push_back(pID3DDevice);
+
 	CD3D9ShaderMaterialRenderer* r = new CD3D9ShaderMaterialRenderer(
-		pID3DDevice, this, nr, vertexShaderProgram, pixelShaderProgram,
+		dev, this, nr, vertexShaderProgram, pixelShaderProgram,
 		callback, getMaterialRenderer(baseMaterial), userData);
 
 	r->drop();
+	dev.clear();
 	return nr;
 }
 
@@ -1919,8 +1916,11 @@
 {
 	s32 nr = -1;
 
+	core::array<IDirect3DDevice9*> dev;
+	dev.push_back(pID3DDevice);
+
 	CD3D9HLSLMaterialRenderer* hlsl = new CD3D9HLSLMaterialRenderer(
-		pID3DDevice, this, nr,
+		dev, this, nr,
 		vertexShaderProgram,
 		vertexShaderEntryPointName,
 		vsCompileTarget,
@@ -1932,6 +1932,7 @@
 		userData);
 
 	hlsl->drop();
+	dev.clear();
 	return nr;
 }
 
diff -r -uw -N irrlicht/source/Irrlicht/CD3D9Driver.h irrlicht_multipatch/source/Irrlicht/CD3D9Driver.h
--- irrlicht/source/Irrlicht/CD3D9Driver.h	2006-10-15 08:48:50.000000000 +0200
+++ irrlicht_multipatch/source/Irrlicht/CD3D9Driver.h	2006-12-05 11:50:44.000000000 +0100
@@ -38,7 +38,7 @@
 		virtual bool endScene( s32 windowId = 0, core::rect<s32>* sourceRect=0 );
 
 		//! queries the features of the driver, returns true if feature is available
-		virtual bool queryFeature(E_VIDEO_DRIVER_FEATURE feature);
+		virtual bool queryFeature(E_VIDEO_DRIVER_FEATURE feature, s32 renderDevice = -1);
 
 		//! sets transformation
 		virtual void setTransform(E_TRANSFORMATION_STATE state, const core::matrix4& mat);
@@ -58,7 +58,7 @@
 		virtual const core::rect<s32>& getViewPort() const;
 
 		//! draws a vertex primitive list
-		virtual void drawVertexPrimitiveList(const void* vertices, s32 vertexCount, const u16* indexList, s32 primitiveCount, E_VERTEX_TYPE vType, scene::E_PRIMITIVE_TYPE pType);
+		virtual void drawVertexPrimitiveList(const void* vertices, s32 vertexCount, const u32* indexList, s32 primitiveCount, E_VERTEX_TYPE vType, scene::E_PRIMITIVE_TYPE pType);
 
 		//! draws an 2d image, using a color (if color is other then Color(255,255,255,255)) and the alpha channel of the texture if wanted.
 		virtual void draw2DImage(video::ITexture* texture, const core::position2d<s32>& destPos,
diff -r -uw -N irrlicht/source/Irrlicht/CD3D9HLSLMaterialRenderer.cpp irrlicht_multipatch/source/Irrlicht/CD3D9HLSLMaterialRenderer.cpp
--- irrlicht/source/Irrlicht/CD3D9HLSLMaterialRenderer.cpp	2006-06-17 08:11:42.000000000 +0200
+++ irrlicht_multipatch/source/Irrlicht/CD3D9HLSLMaterialRenderer.cpp	2006-12-08 15:55:52.000000000 +0100
@@ -23,7 +23,7 @@
 
 
 //! Public constructor
-CD3D9HLSLMaterialRenderer::CD3D9HLSLMaterialRenderer(IDirect3DDevice9* d3ddev,
+	CD3D9HLSLMaterialRenderer::CD3D9HLSLMaterialRenderer(core::array<IDirect3DDevice9*> d3ddev,
 	video::IVideoDriver* driver, s32& outMaterialTypeNr, 
 	const c8* vertexShaderProgram,
 	const c8* vertexShaderEntryPointName,
@@ -34,10 +34,10 @@
 	IShaderConstantSetCallBack* callback, 
 	IMaterialRenderer* baseMaterial,
 	s32 userData)
-	: CD3D9ShaderMaterialRenderer(d3ddev, driver, callback, baseMaterial, userData),
-	VSConstantsTable(0), PSConstantsTable(0)
+	: CD3D9ShaderMaterialRenderer(d3ddev, driver, callback, baseMaterial, userData)
 {
 	outMaterialTypeNr = -1;
+	deviceIndex = 0;
 
 	// now create shaders
 
@@ -47,14 +47,16 @@
 		return;
 	}
 
+	for(u32 idx = 0; idx < d3ddev.size(); ++idx)
+	{
 	if (!createHLSLVertexShader(vertexShaderProgram, 
-		vertexShaderEntryPointName, VERTEX_SHADER_TYPE_NAMES[vsCompileTarget]))
+			vertexShaderEntryPointName, VERTEX_SHADER_TYPE_NAMES[vsCompileTarget], idx))
 		return;
 
 	if (!createHLSLPixelShader(pixelShaderProgram, 
-		pixelShaderEntryPointName, PIXEL_SHADER_TYPE_NAMES[psCompileTarget]))
+			pixelShaderEntryPointName, PIXEL_SHADER_TYPE_NAMES[psCompileTarget], idx))
 		return;
-
+	}
 	// register myself as new material
 	outMaterialTypeNr = Driver->addMaterialRenderer(this);
 }
@@ -62,17 +64,25 @@
 	//! Destructor
 CD3D9HLSLMaterialRenderer::~CD3D9HLSLMaterialRenderer()
 {
-	if (VSConstantsTable)
-		VSConstantsTable->Release();
+	u32 idx = 0;
+	for(idx = 0; idx < VSConstantsTables.size(); ++idx)
+		if (VSConstantsTables[idx])
+			VSConstantsTables[idx]->Release();
+
+	VSConstantsTables.clear();
+
+	for(idx = 0; idx < PSConstantsTables.size(); ++idx)
+		if (PSConstantsTables[idx])
+			PSConstantsTables[idx]->Release();
 
-	if (PSConstantsTable)
-		PSConstantsTable->Release();
+	PSConstantsTables.clear();
 }
 
 
 bool CD3D9HLSLMaterialRenderer::createHLSLVertexShader(const char* vertexShaderProgram,
 													   const char* shaderEntryPointName,
-													   const char* shaderTargetName)
+													   const char* shaderTargetName,
+													   u32 _deviceIndex)
 {
 	if (!vertexShaderProgram)
 		return true;
@@ -83,6 +93,7 @@
 	#ifdef _IRR_D3D_NO_SHADER_DEBUGGING
 
 		// compile without debug info
+		LPD3DXCONSTANTTABLE constTa;
 		
 		HRESULT h = stubD3DXCompileShader(
 			vertexShaderProgram,
@@ -94,10 +105,10 @@
 			0, // no flags 
 			&buffer,
 			&errors,
-			&VSConstantsTable);
-
+			&constTa);
+		VSConstantsTables.push_back(constTa);
 	#else
-
+		LPD3DXCONSTANTTABLE constTa;
 		// compile shader and emitt some debug informations to
 		// make it possible to debug the shader in visual studio
 
@@ -120,8 +131,9 @@
 			D3DXSHADER_DEBUG | D3DXSHADER_SKIPOPTIMIZATION,
 			&buffer,
 			&errors,
-			&VSConstantsTable);
+			&constTa);
 
+		VSConstantsTables.push_back(constTa);
 	#endif
 
 	if (FAILED(h))
@@ -140,8 +152,8 @@
 
 	if (buffer)
 	{
-		if (FAILED(pID3DDevice->CreateVertexShader((DWORD*)buffer->GetBufferPointer(),
-			&VertexShader)))
+		if (FAILED(pID3DDevices[_deviceIndex]->CreateVertexShader((DWORD*)buffer->GetBufferPointer(),
+			&VertexShaders[_deviceIndex])))
 		{
 			os::Printer::log("Could not create hlsl vertex shader.");
 			buffer->Release();
@@ -158,13 +170,15 @@
 
 bool CD3D9HLSLMaterialRenderer::createHLSLPixelShader(const char* pixelShaderProgram, 
 		const char* shaderEntryPointName,
-		const char* shaderTargetName)
+		const char* shaderTargetName,
+		u32 _deviceIndex)
 {
 	if (!pixelShaderProgram)
 		return true;
 
 	LPD3DXBUFFER buffer = 0;
 	LPD3DXBUFFER errors = 0;
+	LPD3DXCONSTANTTABLE constTab;
 	
 	HRESULT h = stubD3DXCompileShader(
 		pixelShaderProgram,
@@ -176,7 +190,9 @@
 		0, // no flags (D3DXSHADER_DEBUG)
 		&buffer,
 		&errors,
-		&PSConstantsTable);
+		&constTab);
+	
+	PSConstantsTables.push_back(constTab);
 
 	if (FAILED(h))
 	{
@@ -194,8 +210,8 @@
 
 	if (buffer)
 	{
-		if (FAILED(pID3DDevice->CreatePixelShader((DWORD*)buffer->GetBufferPointer(),
-			&PixelShader)))
+		if (FAILED(pID3DDevices[_deviceIndex]->CreatePixelShader((DWORD*)buffer->GetBufferPointer(),
+			&PixelShaders[_deviceIndex])))
 		{
 			os::Printer::log("Could not create hlsl pixel shader.");
 			buffer->Release();
@@ -213,7 +229,7 @@
 bool CD3D9HLSLMaterialRenderer::setVariable(bool vertexShader, const c8* name, 
 											const f32* floats, int count)
 {
-	LPD3DXCONSTANTTABLE tbl = vertexShader ? VSConstantsTable : PSConstantsTable;
+	LPD3DXCONSTANTTABLE tbl = vertexShader ? VSConstantsTables[deviceIndex] : PSConstantsTables[deviceIndex];
 	if (!tbl)
 		return false;
 
@@ -231,7 +247,7 @@
 		return false;
 	}
 
-	HRESULT hr = tbl->SetFloatArray(pID3DDevice, hndl, floats, count);
+	HRESULT hr = tbl->SetFloatArray(pID3DDevices[deviceIndex], hndl, floats, count);
 	if (FAILED(hr))
 	{
 		os::Printer::log("Error setting float array for HLSL variable", ELL_WARNING);
@@ -243,8 +259,8 @@
 
 bool CD3D9HLSLMaterialRenderer::OnRender(IMaterialRendererServices* service, E_VERTEX_TYPE vtxtype)
 {
-	if (VSConstantsTable)
-		VSConstantsTable->SetDefaults(pID3DDevice);
+	if (VSConstantsTables[deviceIndex])
+		VSConstantsTables[deviceIndex]->SetDefaults(pID3DDevices[deviceIndex]);
 
 	return CD3D9ShaderMaterialRenderer::OnRender(service, vtxtype);
 }
diff -r -uw -N irrlicht/source/Irrlicht/CD3D9HLSLMaterialRenderer.h irrlicht_multipatch/source/Irrlicht/CD3D9HLSLMaterialRenderer.h
--- irrlicht/source/Irrlicht/CD3D9HLSLMaterialRenderer.h	2006-06-17 08:12:08.000000000 +0200
+++ irrlicht_multipatch/source/Irrlicht/CD3D9HLSLMaterialRenderer.h	2006-12-08 15:53:48.000000000 +0100
@@ -28,7 +28,7 @@
 public:
 
 	//! Public constructor
-	CD3D9HLSLMaterialRenderer(IDirect3DDevice9* d3ddev, video::IVideoDriver* driver, 
+	CD3D9HLSLMaterialRenderer(core::array<IDirect3DDevice9*> d3ddev, video::IVideoDriver* driver, 
 		s32& outMaterialTypeNr, 
 		const c8* vertexShaderProgram,
 		const c8* vertexShaderEntryPointName,
@@ -57,16 +57,18 @@
 
 	bool createHLSLVertexShader(const char* vertexShaderProgram, 
 		const char* shaderEntryPointName,
-		const char* shaderTargetName);
+		const char* shaderTargetName,
+		u32 _deviceIndex);
 
 	bool createHLSLPixelShader(const char* pixelShaderProgram, 
 		const char* shaderEntryPointName,
-		const char* shaderTargetName);
+		const char* shaderTargetName,
+		u32 _deviceIndex);
 
 	void printHLSLVariables(LPD3DXCONSTANTTABLE table);
 	
-	LPD3DXCONSTANTTABLE VSConstantsTable;
-	LPD3DXCONSTANTTABLE PSConstantsTable;
+	core::array<LPD3DXCONSTANTTABLE> VSConstantsTables;
+	core::array<LPD3DXCONSTANTTABLE> PSConstantsTables;
 };
 
 
